<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( "3\nIllegal access" );

// Get Parameters
$app = JFactory::getApplication('site');
$componentParams = $app->getParams('com_nagioscheck4updates');
$login = $componentParams->get('login', "");
$password = $componentParams->get('password', "");
$allowedips = $componentParams->get('allowedips', "");
$ignore = $componentParams->get('ignore', "");

// Clean allowed ips
$t_ips = explode("\n", $allowedips);
foreach($t_ips AS $key => $val) {
  $t_ips[$key] = trim($val);
  if (!$val) {
    unset($t_ips[$key]);
  }
}

// Format & clean update ignored list
$t_ign = array();
$t = explode("\n", $ignore);
foreach($t AS $key => $val) {
  if (trim($val)) {
    $t_ign[trim($val)] = trim($val);
  }
}

// IP verification
if ((!empty($t_ips)) && (!in_array( $_SERVER["REMOTE_ADDR"], $t_ips))) {
  //echo "<pre>";
  //print_r($t_ips);
  //echo "</pre>";
  die("3\nAccess denied for ".$_SERVER["REMOTE_ADDR"]);
}

// Password verification
if ((!isset($_SERVER['PHP_AUTH_USER'])) || ( ($_SERVER['PHP_AUTH_USER'] != $login) || ($_SERVER['PHP_AUTH_PW'] != $password) )) {
  header('WWW-Authenticate: Basic realm="My Realm"');
  header('HTTP/1.0 401 Unauthorized');
  die("3\nBad authentification.");
}

// Updates checking
$updater = JUpdater::getInstance();
$options = array();
$options['location']='';
$options['update_site_id']='';
$updater->findUpdates($options);

$db = JFactory::getDbo();
$query = $db->getQuery(true);
$query->select('*');
$query->from('#__updates')->where('extension_id != 0');
$db->setQuery($query);
$updates = $db->loadObjectList();

// Remove elements to ignore from the upgrades list
foreach($updates as $key => $update){
  if (isset($t_ign[trim($update->element)])) {
    unset($updates[$key]);
  }
}

$nbre_maj = count($updates);

if ($nbre_maj == 0) {
  echo "0";
} elseif ($nbre_maj < 10) {
  echo "1";
} else {
  echo "2";
}
echo "\n$nbre_maj waiting update(s)";

// Print what is to update
$compos = array();
foreach($updates as $update){
	//$compos[] = $update->name." : ".$update->element." - ".$update->version."\n";
	$compos[] = $update->element." ".$update->version;
}
echo ": ".implode(", ", $compos);

// Eventualy print ignore elements.
if (count($t_ign)) { 
  echo ". Ignored element(s): ".implode(", ", $t_ign)."."; 
}

exit;
?>
